# ===================================================================================
#
# SharePoint Products - CopyMove Log File Merger
#
# ===================================================================================

$Host.UI.RawUI.WindowTitle = "Merging CopyMove log file"
$0 = $myInvocation.MyCommand.Definition
$dp0 = [System.IO.Path]::GetDirectoryName($0)
. "$dp0\Functions.ps1"

$myWindowsID=[System.Security.Principal.WindowsIdentity]::GetCurrent()
$myWindowsPrincipal=new-object System.Security.Principal.WindowsPrincipal($myWindowsID)
$adminRole=[System.Security.Principal.WindowsBuiltInRole]::Administrator
if ($myWindowsPrincipal.IsInRole($adminRole))
{
	$Host.UI.RawUI.BackgroundColor = "DarkBlue"
	clear-host
} else
{
	$newProcess = new-object System.Diagnostics.ProcessStartInfo "PowerShell";
	$newProcess.Arguments = $myInvocation.MyCommand.Definition;
    $newProcess.Verb = "runas";
    [System.Diagnostics.Process]::Start($newProcess);
    exit
}

Load-SharePoint-Powershell

cd $dp0

Write-Host ""
Write-Host ""
Write-Host ""
Write-Host ""
Write-Host "- Merging recent CopyMove log events from all servers in the farm"
Merge-SPLogFile -Path "..\spp.log" -Area "SharePoint Products" -Overwrite
Write-Host "- Log events written to the file spp.log"
Write-Host "- Done"

