# Make sure we run as administrator
$myWindowsID=[System.Security.Principal.WindowsIdentity]::GetCurrent()
$myWindowsPrincipal=new-object System.Security.Principal.WindowsPrincipal($myWindowsID)
$adminRole=[System.Security.Principal.WindowsBuiltInRole]::Administrator
if ($myWindowsPrincipal.IsInRole($adminRole))
{
	$Host.UI.RawUI.BackgroundColor = "DarkBlue"
	clear-host
} else
{
	$newProcess = new-object System.Diagnostics.ProcessStartInfo "PowerShell";
	$newProcess.Arguments = $myInvocation.MyCommand.Definition;
   	$newProcess.Verb = "runas";
	[System.Diagnostics.Process]::Start($newProcess);
	exit
}

# Restart services to remove any file locks on the CopyMove assemblies
Restart-Service W3SVC -force
Restart-Service SPTimerV4

# load System.EnterpriseServices assembly
[Reflection.Assembly]::LoadWithPartialName("System.EnterpriseServices") > $null

# create an instance of publish class
[System.EnterpriseServices.Internal.Publish] $publish = new-object System.EnterpriseServices.Internal.Publish

$assemblyNames = @( `
	"SharePointProducts.CopyMove.Workflow,Version=2.0.0.0,Culture=neutral,PublicKeyToken=9e95445247029289", `
	"SharePointProducts.CopyMove.resources,Version=2.0.0.0,Culture=de-DE,PublicKeyToken=9e95445247029289", `
	"SharePointProducts.CopyMove.resources,Version=2.0.0.0,Culture=es-ES,PublicKeyToken=9e95445247029289", `
	"SharePointProducts.CopyMove.resources,Version=2.0.0.0,Culture=fr-FR,PublicKeyToken=9e95445247029289", `
	"SharePointProducts.CopyMove,Version=2.0.0.0,Culture=neutral,PublicKeyToken=9e95445247029289", `
	"SharePointProducts.Platform.resources,Version=2.0.0.0,Culture=de-DE,PublicKeyToken=9e95445247029289", `
	"SharePointProducts.Platform.resources,Version=2.0.0.0,Culture=es-ES,PublicKeyToken=9e95445247029289", `
	"SharePointProducts.Platform.resources,Version=2.0.0.0,Culture=fr-FR,PublicKeyToken=9e95445247029289", `
	"SharePointProducts.Platform,Version=2.0.0.0,Culture=neutral,PublicKeyToken=9e95445247029289", `
	"SharePointProducts.Blocks,Version=3.5.0.0,Culture=neutral,PublicKeyToken=9e95445247029289", `
	"SharePointProducts.Common,Version=3.5.0.0,Culture=neutral,PublicKeyToken=9e95445247029289" )
$assemblyLocations = @()

# Attempt to remove all assemblies
Write-Host "Removing the CopyMove assemblies from the Global Assembly Cache"
foreach ($assemblyName in $assemblyNames)
{
	$index = $assemblyName.IndexOf(",")
	$assemblyFilename = $assemblyName.Substring(0, $index)
	$assemblyFilename += ".dll"

    try
    {
	   $assembly = [System.Reflection.Assembly]::Load($assemblyName)
       $assemblyLocations += $assembly.Location
       Write-Host "Removing $assemblyFilename"
       $publish.GacRemove($assembly.Location)       
    }
    catch [System.IO.IOException]
    {
    }
}

# Check if some assemblies where not removed afterall
$remainingAssemblies = @()
foreach ($assemblyLocation in $assemblyLocations)
{
    $assemblyStillExists = Test-Path $assemblyLocation
    if ($assemblyStillExists)
    {
        $remainingAssemblies += $assemblyLocation
    }
} 

# Display operation status
if ($remainingAssemblies.length -eq 0)
{
    Write-Host -foregroundcolor Green "Success - removed all CopyMove assemblies from the Global Assembly Cache"
} else
{
    Write-Host -foregroundcolor Red "Error - unable to remove the following assemblies from the Global Assembly Cache. Please try again!"
    foreach ($remainingAssembly in $remainingAssemblies)
    {
        Write-Host -foregroundcolor Red "- $remainingAssembly"
    }
}

Write-Host "Press any key to continue ..."
$x = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")
